Package: gendercoder
Title: Recodes Sex/Gender Descriptions into a Standard Set
Version: 0.1.1
Authors@R: c(
  person("Yaoxiang", "Li", role = c("aut", "cre"),
        email = "liyaoxiang@outlook.com", 
        comment = c(ORCID = "0000-0001-9200-1016")),
  person("Jennifer", "Beaudry", role = "aut",
    email = "jbeaudry@swin.edu.au",
    comment = c(ORCID = "0000-0003-1596-6708")),
  person("Emily", "Kothe", role = "aut",
    email = "emily.kothe@deakin.edu.au",
    comment = c(ORCID = "0000-0003-1210-0554")),
  person("Felix", "Singleton Thorn", role = "aut",
    email = "fsingletonthorn@gmail.com", 
    comment = c(ORCID = "0000-0002-0237-6146")),
  person("Rhydwyn", "McGuire", role = "aut",
    email = "rhydwyn@rhydwyn.net"),
  person("Nicholas", "Tierney", 
         role = "aut",
         email = "nicholas.tierney@gmail.com", 
         comment = c(ORCID = "0000-0003-1460-8722")),
  person("Mathew", "Ling", 
         role = "aut",
         email = "mathewtyling@gmail.com", 
         comment = c(ORCID = "0000-0002-0940-2538")),       
  person("Julia", "Silge", 
         role = "rev",
    comment = "Julia reviewed the package (v. 0.0.0.9000) for rOpenSci, see <https://github.com/ropensci/software-review/issues/435>"),
  person("Elin", "Waring", 
         role = "rev",
  comment = "Elin reviewed the package (v. 0.0.0.9000) for rOpenSci, see <https://github.com/ropensci/software-review/issues/435>")
  )
Description: Provides dictionary-based tools for recoding free-text gender
    responses into consistent categories while preserving gender diversity where
    possible. The package standardises spelling, capitalization, whitespace, and
    common variants through curated named character-vector dictionaries, supports
    either detailed or collapsed output categories, and can retain original
    unmatched responses for manual review. It also includes helpers for creating
    custom dictionaries from approximate string matches and a local interactive
    application for recoding uploaded data files.
Depends: R (>= 3.0.0)
Maintainer: Yaoxiang Li <liyaoxiang@outlook.com>
License: GPL-2
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.3
Suggests: knitr, rmarkdown, bs4Dash, haven, shiny
VignetteBuilder: knitr
URL: https://github.com/ropensci/gendercoder
BugReports: https://github.com/ropensci/gendercoder/issues
NeedsCompilation: no
Packaged: 2026-05-12 23:45:55 UTC; Bach
Author: Yaoxiang Li [aut, cre] (ORCID: <https://orcid.org/0000-0001-9200-1016>),
  Jennifer Beaudry [aut] (ORCID: <https://orcid.org/0000-0003-1596-6708>),
  Emily Kothe [aut] (ORCID: <https://orcid.org/0000-0003-1210-0554>),
  Felix Singleton Thorn [aut] (ORCID:
    <https://orcid.org/0000-0002-0237-6146>),
  Rhydwyn McGuire [aut],
  Nicholas Tierney [aut] (ORCID: <https://orcid.org/0000-0003-1460-8722>),
  Mathew Ling [aut] (ORCID: <https://orcid.org/0000-0002-0940-2538>),
  Julia Silge [rev] (Julia reviewed the package (v. 0.0.0.9000) for
    rOpenSci, see
    <https://github.com/ropensci/software-review/issues/435>),
  Elin Waring [rev] (Elin reviewed the package (v. 0.0.0.9000) for
    rOpenSci, see
    <https://github.com/ropensci/software-review/issues/435>)
Repository: CRAN
Date/Publication: 2026-05-18 18:10:16 UTC
Built: R 4.5.2; ; 2026-05-18 19:35:14 UTC; unix

Package: gendercoder
Title: Recodes Sex/Gender Descriptions into a Standard Set
Version: 0.1.1
Authors@R: c(
  person("Yaoxiang", "Li", role = c("aut", "cre"),
        email = "liyaoxiang@outlook.com", 
        comment = c(ORCID = "0000-0001-9200-1016")),
  person("Jennifer", "Beaudry", role = "aut",
    email = "jbeaudry@swin.edu.au",
    comment = c(ORCID = "0000-0003-1596-6708")),
  person("Emily", "Kothe", role = "aut",
    email = "emily.kothe@deakin.edu.au",
    comment = c(ORCID = "0000-0003-1210-0554")),
  person("Felix", "Singleton Thorn", role = "aut",
    email = "fsingletonthorn@gmail.com", 
    comment = c(ORCID = "0000-0002-0237-6146")),
  person("Rhydwyn", "McGuire", role = "aut",
    email = "rhydwyn@rhydwyn.net"),
  person("Nicholas", "Tierney", 
         role = "aut",
         email = "nicholas.tierney@gmail.com", 
         comment = c(ORCID = "0000-0003-1460-8722")),
  person("Mathew", "Ling", 
         role = "aut",
         email = "mathewtyling@gmail.com", 
         comment = c(ORCID = "0000-0002-0940-2538")),       
  person("Julia", "Silge", 
         role = "rev",
    comment = "Julia reviewed the package (v. 0.0.0.9000) for rOpenSci, see <https://github.com/ropensci/software-review/issues/435>"),
  person("Elin", "Waring", 
         role = "rev",
  comment = "Elin reviewed the package (v. 0.0.0.9000) for rOpenSci, see <https://github.com/ropensci/software-review/issues/435>")
  )
Description: Provides dictionary-based tools for recoding free-text gender
    responses into consistent categories while preserving gender diversity where
    possible. The package standardises spelling, capitalization, whitespace, and
    common variants through curated named character-vector dictionaries, supports
    either detailed or collapsed output categories, and can retain original
    unmatched responses for manual review. It also includes helpers for creating
    custom dictionaries from approximate string matches and a local interactive
    application for recoding uploaded data files.
Depends: R (>= 3.0.0)
Maintainer: Yaoxiang Li <liyaoxiang@outlook.com>
License: GPL-2
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.3
Suggests: knitr, rmarkdown, bs4Dash, haven, shiny
VignetteBuilder: knitr
URL: https://github.com/ropensci/gendercoder
BugReports: https://github.com/ropensci/gendercoder/issues
NeedsCompilation: no
Packaged: 2026-05-12 23:45:55 UTC; Bach
Author: Yaoxiang Li [aut, cre] (ORCID: <https://orcid.org/0000-0001-9200-1016>),
  Jennifer Beaudry [aut] (ORCID: <https://orcid.org/0000-0003-1596-6708>),
  Emily Kothe [aut] (ORCID: <https://orcid.org/0000-0003-1210-0554>),
  Felix Singleton Thorn [aut] (ORCID:
    <https://orcid.org/0000-0002-0237-6146>),
  Rhydwyn McGuire [aut],
  Nicholas Tierney [aut] (ORCID: <https://orcid.org/0000-0003-1460-8722>),
  Mathew Ling [aut] (ORCID: <https://orcid.org/0000-0002-0940-2538>),
  Julia Silge [rev] (Julia reviewed the package (v. 0.0.0.9000) for
    rOpenSci, see
    <https://github.com/ropensci/software-review/issues/435>),
  Elin Waring [rev] (Elin reviewed the package (v. 0.0.0.9000) for
    rOpenSci, see
    <https://github.com/ropensci/software-review/issues/435>)
Repository: CRAN
Date/Publication: 2026-05-18 18:10:16 UTC
Built: R 4.6.0; ; 2026-05-18 19:10:46 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# gendercoder

<!-- badges: start -->

[![CRAN
status](https://www.r-pkg.org/badges/version/gendercoder)](https://CRAN.R-project.org/package=gendercoder)
[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://lifecycle.r-lib.org/articles/stages.html#stable)
[![Project Status: Active - The project has reached a stable, usable
state and is being actively
developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)
[![ROpenSci
status](https://badges.ropensci.org/435_status.svg)](https://github.com/ropensci/software-review/issues/435)
[![R-CMD-check](https://github.com/ropensci/gendercoder/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/ropensci/gendercoder/actions/workflows/R-CMD-check.yaml)
[![Codecov test
coverage](https://codecov.io/gh/ropensci/gendercoder/graph/badge.svg)](https://app.codecov.io/gh/ropensci/gendercoder)
<!-- badges: end -->

The goal of gendercoder is to allow simple re-coding of free-text gender
responses. This is intended to permit representation of gender diversity
while managing misleading responses and the workload implications of
manual coding.

## Installation

You can install the development version from GitHub with:

``` r
devtools::install_github("ropensci/gendercoder")
library(gendercoder)
```

## Basic use

The gendercoder package permits the efficient re-coding of free-text
gender responses. It contains two built-in English output dictionaries,
a default `manylevels_en` dictionary which corrects spelling and
standardises terms while maintaining the diversity of responses and a
`fewlevels_en` dictionary which contains fewer gender categories: `man`,
`woman`, `boy`, `girl`, and `sex and gender diverse`.

The core function, `recode_gender()`, takes 3 arguments,

- `gender` the vector of free-text gender,

- `dictionary` the preferred dictionary, and

- `retain_unmatched` a logical indicating whether original values should
  be carried over if there is no match.

Basic usage is demonstrated below.

``` r
library(gendercoder)

df <- data.frame(
  stringsAsFactors = FALSE,
  gender = c("male", "MALE", "mle", "I am male", "femail", "female", "enby")
)

df$manylevels_gender <- recode_gender(
  df$gender,
  dictionary = manylevels_en,
  retain_unmatched = TRUE
)
#> Results not matched from the dictionary have been filled with the user inputted values
df$fewlevels_gender <- recode_gender(
  df$gender,
  dictionary = fewlevels_en,
  retain_unmatched = FALSE
)
df
#>      gender manylevels_gender       fewlevels_gender
#> 1      male               man                    man
#> 2      MALE               man                    man
#> 3       mle               man                    man
#> 4 I am male         I am male                   <NA>
#> 5    femail             woman                  woman
#> 6    female             woman                  woman
#> 7      enby        non-binary sex and gender diverse
```

The package also includes a local Shiny app for interactive recoding:

``` r
gendercoder_app()
```

The app uses a `bs4Dash` interface and accepts `.csv`, `.dta`, `.sav`,
`.rds`, `.rda`, and `.RData` files. Stata and SPSS files require the
optional `haven` package. The app displays the selected gender column
and the recoded output column, then lets you download the full recoded
data.

## Contributing to this package

This package is a reflection of the cultural context of the package
contributors. We acknowledge that understandings of gender are bound by
both culture and time and are continually changing. As such, we welcome
issues and pull requests to make the package more inclusive, more
reflective of current understandings of gender-inclusive languages
and/or suitable for a broader range of cultural contexts. We
particularly welcome addition of non-English dictionaries or of other
gender-diverse responses to the `manylevels_en` and `fewlevels_en`
dictionaries.

The [Adding to the dictionary](vignettes/a02_add_dictionary.Rmd)
vignette includes information about how to make changes to the
dictionary either for your own use or when contributing to the
gendercoder package.

## Acknowledgement of Country

We acknowledge the Wurundjeri people of the Kulin Nation as the
custodians of the land on which this package was developed and pay
respects to elders past, present and future.

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup, echo = FALSE, message=FALSE---------------------------------------
df <- data.frame(
  gender = c("male", "enby", "womn", "mlae", "mann", "frau", "femme", "homme", "nin"),
  stringsAsFactors = FALSE
)

## ----example-data, message=FALSE----------------------------------------------
library(gendercoder)
df

## ----new-dictionary-----------------------------------------------------------
new_dictionary <- c(
  mann = "man", 
  frau = "woman", 
  femme = "woman", 
  homme = "man", 
  nin = "man")

new_dictionary_df <- df
new_dictionary_df$recoded_gender <- recode_gender(
  df$gender,
  dictionary = new_dictionary,
  retain_unmatched = TRUE
)
new_dictionary_df


## ----inline-augmentation------------------------------------------------------
inline_df <- df
inline_df$recoded_gender <- recode_gender(
  df$gender,
  dictionary = c(manylevels_en, new_dictionary),
  retain_unmatched = TRUE
)
inline_df

## ----stepped-augmentation-----------------------------------------------------
manylevels_plus <-  c(manylevels_en, new_dictionary)

stepped_df <- df
stepped_df$recoded_gender <- recode_gender(
  df$gender,
  dictionary = manylevels_plus,
  retain_unmatched = TRUE
)
stepped_df

## ----replacing-dictionaries, eval=FALSE---------------------------------------
# manylevels_en <-  manylevels_plus
# usethis::use_data(manylevels_en, overwrite = TRUE)

shiny::shinyServer(function(input, output) {
  uploaded_data <- shiny::reactive({
    shiny::req(input$file1)
    read_app_data(input$file1$datapath, input$file1$name)
  })

  output$varselect <- shiny::renderUI({
    shiny::selectInput(
      "vars",
      "Gender column:",
      names(uploaded_data()),
      names(uploaded_data()),
      multiple = FALSE
    )
  })

  coded_data <- shiny::reactive({
    shiny::req(input$vars)

    dictionary <- switch(input$dictionary,
      manylevels_en = gendercoder::manylevels_en,
      fewlevels_en = gendercoder::fewlevels_en
    )

    data <- uploaded_data()
    data$recoded_gender <- gendercoder::recode_gender(data[[input$vars]], dictionary)
    data
  })

  output$out1 <- shiny::renderTable({
    data <- coded_data()
    data[, c(input$vars, "recoded_gender"), drop = FALSE]
  })

  output$downloadData <- shiny::downloadHandler(
    filename = function() {
      paste0(tools::file_path_sans_ext(input$file1$name), "_coded", input$dlformat)
    },
    content = function(file) {
      data <- coded_data()

      gendercoder:::write_app_data(data, file, input$dlformat)
    }
  )
})

bs4Dash::dashboardPage(
  title = "gendercoder",
  header = bs4Dash::dashboardHeader(
    title = "gendercoder",
    status = "white",
    border = TRUE
  ),
  sidebar = bs4Dash::dashboardSidebar(
    skin = "light",
    status = "primary",
    brandColor = "primary",
    bs4Dash::sidebarMenu(
      bs4Dash::menuItem("Recoder", tabName = "recoder", icon = shiny::icon("table"))
    )
  ),
  body = bs4Dash::dashboardBody(
    bs4Dash::tabItems(
      bs4Dash::tabItem(
        tabName = "recoder",
        shiny::fluidRow(
          bs4Dash::box(
            title = "Input",
            width = 4,
            status = "primary",
            solidHeader = TRUE,
            shiny::fileInput(
              "file1",
              "Choose data file",
              multiple = FALSE,
              accept = c(
                "text/csv",
                "text/comma-separated-values,text/plain",
                ".csv",
                ".dta",
                ".sav",
                ".rds",
                ".rda",
                ".RData"
              ),
              placeholder = ".csv, .dta, .sav, .rds, .rda, or .RData"
            ),
            shiny::radioButtons(
              "dictionary",
              "Coding dictionary:",
              choiceValues = c("manylevels_en", "fewlevels_en"),
              choiceNames = c("Many levels - English", "Few levels - English"),
              selected = "manylevels_en"
            ),
            shiny::htmlOutput("varselect"),
            shiny::radioButtons(
              "dlformat",
              "Download format:",
              choiceValues = c(".csv", ".sav", ".dta", ".rds", ".rda"),
              choiceNames = c(".csv", ".sav (SPSS)", ".dta (Stata)", ".rds", ".rda"),
              selected = ".csv"
            ),
            shiny::downloadButton("downloadData", "Download")
          ),
          bs4Dash::box(
            title = "Preview",
            width = 8,
            status = "primary",
            solidHeader = TRUE,
            shiny::tableOutput("out1")
          )
        )
      )
    )
  )
)

## ----message = FALSE, warning= FALSE------------------------------------------
library(gendercoder)

count_values <- function(x, name = "value") {
  counts <- sort(table(x, useNA = "ifany"), decreasing = TRUE)
  out <- data.frame(value = names(counts), count = as.integer(counts))
  names(out)[1] <- name
  out
}

knitr::kable(
  count_values(sample$Gender, "Gender"),
  caption = "Summary of gender categories before coding"
)

## -----------------------------------------------------------------------------
manylevels_sample <- sample
manylevels_sample$recoded_gender <- recode_gender(
  gender = manylevels_sample$Gender,
  dictionary = manylevels_en
)

knitr::kable(
  head(manylevels_sample, 10),
  caption = "The manylevels_en dictionary applied to `head(sample)`"
)

knitr::kable(
  count_values(na.omit(manylevels_sample$recoded_gender), "recoded_gender"),
  caption = "Summary of gender categories after use of the *manylevels_en* dictionary"
)


## -----------------------------------------------------------------------------

knitr::kable(
  manylevels_sample[is.na(manylevels_sample$recoded_gender), ],
  caption = "All responses not classified by the built-in dictionary"
)


## -----------------------------------------------------------------------------
fewlevels_sample <- sample
fewlevels_sample$recoded_gender <- recode_gender(
  gender = fewlevels_sample$Gender,
  dictionary = fewlevels_en
)

knitr::kable(
  head(fewlevels_sample, 10),
  caption = "The fewlevels_en dictionary applied to `head(sample)`"
)

knitr::kable(
  count_values(fewlevels_sample$recoded_gender, "recoded_gender"),
  caption = "Summary of gender categories after use of the *fewlevels_en* dictionary"
)

## -----------------------------------------------------------------------------
# name of the vector element is the user input value and the vector element is the 
# replacement value corresponding to that name as a lower case string.
custom_dictionary <- c(
  masculino = "man",
  hombre = "man",
  mujer = "woman",
  femenina = "woman"
)

str(custom_dictionary)

## -----------------------------------------------------------------------------

combined_sample <- sample
combined_sample$recoded_gender <- recode_gender(
  gender = combined_sample$Gender,
  dictionary = c(fewlevels_en, custom_dictionary)
)

knitr::kable(
  count_values(combined_sample$recoded_gender, "recoded_gender"),
  caption = "Summary of gender categories after use of the combined dictionaries"
)

knitr::kable(
  combined_sample[is.na(combined_sample$recoded_gender), ],
  caption = "All responses not classified by the combined dictionaries"
)

## -----------------------------------------------------------------------------
retained_sample <- sample
retained_sample$recoded_gender <- recode_gender(
  gender = retained_sample$Gender,
  dictionary = c(fewlevels_en, custom_dictionary),
  retain_unmatched = TRUE
)

knitr::kable(
  count_values(retained_sample$recoded_gender, "recoded_gender"),
  caption = "Summary of gender categories after use of the combined dictionary and `retain_unmatched = TRUE`"
)

#' Launch the gendercoder Shiny app
#'
#' Code data interactively in a Shiny app that runs locally in RStudio or a web
#' browser using a \pkg{bs4Dash} interface. The app supports CSV, Stata, SPSS,
#' RDS, and R data files. Stata and SPSS files require the optional
#' \pkg{haven} package.
#'
#' @param ... arguments to pass to \code{shiny::runApp()}
#'
#' @return Called for its side effect of launching a Shiny app.
#' @export
#'
#' @examples
#' if (interactive()) {
#' gendercoder_app()
#' }
gendercoder_app <- function(...) {
  packages <- c("bs4Dash", "shiny")
  launch_gendercoder_app(packages, ...)
}

launch_gendercoder_app <- function(packages, ...) {
  if (!check_app_packages(packages)) {
    return(invisible(FALSE))
  }

  shiny::runApp(appDir = system.file("app", package = "gendercoder"), ...)
}

check_app_packages <- function(packages) {
  available <- vapply(packages, requireNamespace, logical(1), quietly = TRUE)

  if (!all(available)) {
    warning(
      "You need to install the following packages to run the app: ",
      paste(packages[!available], collapse = ", "),
      call. = FALSE
    )
    return(FALSE)
  }

  TRUE
}

require_app_packages <- function(packages) {
  if (!check_app_packages(packages)) {
    stop(
      "Install the missing package before using this file type.",
      call. = FALSE
    )
  }

  TRUE
}

read_app_data <- function(path, name = path) {
  extension <- tolower(tools::file_ext(name))

  switch(extension,
    csv = utils::read.csv(path, stringsAsFactors = FALSE, check.names = FALSE),
    dta = {
      require_app_packages("haven")
      haven::read_dta(path)
    },
    sav = {
      require_app_packages("haven")
      haven::read_sav(path)
    },
    rds = readRDS(path),
    rda = read_first_r_data_object(path),
    rdata = read_first_r_data_object(path),
    stop("Unsupported file type: ", extension, call. = FALSE)
  )
}

read_first_r_data_object <- function(path) {
  data_env <- new.env(parent = emptyenv())
  object_names <- load(path, envir = data_env)

  if (length(object_names) == 0) {
    stop("The R data file does not contain any objects", call. = FALSE)
  }

  data_env[[object_names[[1]]]]
}

write_app_data <- function(data, file, extension) {
  switch(tolower(extension),
    ".csv" = utils::write.csv(data, file, row.names = FALSE, na = ""),
    ".sav" = {
      require_app_packages("haven")
      haven::write_sav(data, file)
    },
    ".dta" = {
      require_app_packages("haven")
      haven::write_dta(data, file)
    },
    ".rds" = saveRDS(data, file),
    ".rda" = {
      recoded_data <- data
      save(recoded_data, file = file, version = 2)
    },
    stop("Unsupported file type: ", extension, call. = FALSE)
  )
}

stopifnot(
  grepl("non-binary", recode_gender("enby", dictionary = manylevels_en, retain_unmatched = TRUE)),
  grepl("man", recode_gender("mlae", dictionary = manylevels_en, retain_unmatched = TRUE)),
  grepl("woman", recode_gender("famela", dictionary = manylevels_en, retain_unmatched = TRUE)),
  grepl("woman", recode_gender("my sex is female", dictionary = manylevels_en, retain_unmatched = TRUE)),
  grepl("man", recode_gender("makle", dictionary = manylevels_en, retain_unmatched = TRUE)),
  grepl("woman", recode_gender("female only", dictionary = manylevels_en, retain_unmatched = TRUE)),
  grepl("man", recode_gender("masculine", dictionary = manylevels_en, retain_unmatched = TRUE)),
  grepl("genderfluid", recode_gender("gender-fluid", dictionary = manylevels_en, retain_unmatched = TRUE)),
  grepl("man", recode_gender("\u7537", dictionary = manylevels_en, retain_unmatched = TRUE)),
  grepl("woman", recode_gender("\u5973", dictionary = manylevels_en, retain_unmatched = TRUE)),
  grepl("sex and gender diverse", recode_gender("enby", dictionary = fewlevels_en, retain_unmatched = TRUE)),
  grepl("woman", recode_gender("my sex is female", dictionary = fewlevels_en, retain_unmatched = TRUE)),
  grepl("man", recode_gender("makle", dictionary = fewlevels_en, retain_unmatched = TRUE)),
  grepl("woman", recode_gender("female only", dictionary = fewlevels_en, retain_unmatched = TRUE)),
  grepl("man", recode_gender("masculine", dictionary = fewlevels_en, retain_unmatched = TRUE)),
  grepl("sex and gender diverse", recode_gender("gender-fluid", dictionary = fewlevels_en, retain_unmatched = TRUE)),
  grepl("sex and gender diverse", recode_gender("enby", dictionary = fewlevels_en, retain_unmatched = FALSE)),
  grepl("man", recode_gender("\u7537", dictionary = fewlevels_en, retain_unmatched = TRUE)),
  grepl("woman", recode_gender("\u5973", dictionary = fewlevels_en, retain_unmatched = TRUE))
)

stopifnot(
  recode_gender("enby", dictionary = manylevels_en, retain_unmatched = TRUE) !=
    recode_gender("enby", dictionary = fewlevels_en, retain_unmatched = TRUE)
)

stopifnot(is.na(recode_gender("apache", dictionary = fewlevels_en, retain_unmatched = FALSE)))

message_output <- capture.output(
  invisible(recode_gender(c("mlae", "fish"), retain_unmatched = TRUE)),
  type = "message"
)
stopifnot(grepl(
  "Results not matched from the dictionary have been filled with the user inputted values",
  message_output
))

stopifnot(identical(length(1:3), length(recode_gender(1:3))))

error_message <- tryCatch(
  recode_gender(c("mlae"), dictionary = 1:7),
  error = conditionMessage
)
stopifnot(grepl("The supplied dictionary is not a character vector", error_message))

dictionary_error <- tryCatch(
  gender_create_dictionary("maile", dictionary = 1:7),
  error = conditionMessage
)
stopifnot(grepl("The supplied dictionary is not a character vector", dictionary_error))

distance_error <- tryCatch(
  gender_create_dictionary("maile", max_distance = -1),
  error = conditionMessage
)
stopifnot(grepl("max_distance must be a single non-negative number", distance_error))

app_test_data <- data.frame(gender = c("male", "enby"), stringsAsFactors = FALSE)
app_csv <- tempfile(fileext = ".csv")
app_dta <- tempfile(fileext = ".dta")
app_sav <- tempfile(fileext = ".sav")
app_rds <- tempfile(fileext = ".rds")
app_rda <- tempfile(fileext = ".rda")
app_rdata <- tempfile(fileext = ".RData")
utils::write.csv(app_test_data, app_csv, row.names = FALSE)
haven::write_dta(app_test_data, app_dta)
haven::write_sav(app_test_data, app_sav)
saveRDS(app_test_data, app_rds)
save(app_test_data, file = app_rda, version = 2)
save(app_test_data, file = app_rdata, version = 2)

stopifnot(identical(as.data.frame(gendercoder:::read_app_data(app_csv)), app_test_data))
stopifnot(identical(as.character(as.data.frame(gendercoder:::read_app_data(app_dta))$gender), app_test_data$gender))
stopifnot(identical(as.character(as.data.frame(gendercoder:::read_app_data(app_sav))$gender), app_test_data$gender))
stopifnot(identical(gendercoder:::read_app_data(app_rds), app_test_data))
stopifnot(identical(gendercoder:::read_app_data(app_rda), app_test_data))
stopifnot(identical(gendercoder:::read_app_data(app_rdata), app_test_data))

written_csv <- tempfile(fileext = ".csv")
written_dta <- tempfile(fileext = ".dta")
written_sav <- tempfile(fileext = ".sav")
written_rds <- tempfile(fileext = ".rds")
written_rda <- tempfile(fileext = ".rda")

gendercoder:::write_app_data(app_test_data, written_csv, ".csv")
gendercoder:::write_app_data(app_test_data, written_dta, ".dta")
gendercoder:::write_app_data(app_test_data, written_sav, ".sav")
gendercoder:::write_app_data(app_test_data, written_rds, ".rds")
gendercoder:::write_app_data(app_test_data, written_rda, ".rda")

stopifnot(identical(utils::read.csv(written_csv, stringsAsFactors = FALSE), app_test_data))
stopifnot(identical(as.character(as.data.frame(haven::read_dta(written_dta))$gender), app_test_data$gender))
stopifnot(identical(as.character(as.data.frame(haven::read_sav(written_sav))$gender), app_test_data$gender))
stopifnot(identical(readRDS(written_rds), app_test_data))
loaded_objects <- load(written_rda)
stopifnot(
  identical(loaded_objects, "recoded_data"),
  identical(recoded_data, app_test_data)
)

unsupported_write_error <- tryCatch(
  gendercoder:::write_app_data(app_test_data, tempfile(fileext = ".txt"), ".txt"),
  error = conditionMessage
)
stopifnot(grepl("Unsupported file type: .txt", unsupported_write_error))

unsupported_error <- tryCatch(
  gendercoder:::read_app_data(tempfile(fileext = ".txt")),
  error = conditionMessage
)
stopifnot(grepl("Unsupported file type: txt", unsupported_error))

empty_rda <- tempfile(fileext = ".rda")
save(list = character(), file = empty_rda)
empty_rda_error <- tryCatch(
  gendercoder:::read_app_data(empty_rda),
  error = conditionMessage
)
stopifnot(grepl("The R data file does not contain any objects", empty_rda_error))

missing_app_package_warning <- NULL
missing_app_packages <- withCallingHandlers(
  gendercoder:::check_app_packages("gendercoderDefinitelyMissingPackage"),
  warning = function(w) {
    missing_app_package_warning <<- conditionMessage(w)
    invokeRestart("muffleWarning")
  }
)
stopifnot(
  identical(missing_app_packages, FALSE),
  grepl("You need to install the following packages to run the app", missing_app_package_warning)
)

missing_app_launch_warning <- NULL
missing_app_launch <- withCallingHandlers(
  gendercoder:::launch_gendercoder_app("gendercoderDefinitelyMissingPackage"),
  warning = function(w) {
    missing_app_launch_warning <<- conditionMessage(w)
    invokeRestart("muffleWarning")
  }
)
stopifnot(
  identical(missing_app_launch, FALSE),
  grepl("gendercoderDefinitelyMissingPackage", missing_app_launch_warning)
)

missing_file_package_error <- NULL
missing_file_package_warning <- NULL
withCallingHandlers(
  missing_file_package_error <- tryCatch(
    gendercoder:::require_app_packages("gendercoderDefinitelyMissingPackage"),
    error = conditionMessage
  ),
  warning = function(w) {
    missing_file_package_warning <<- conditionMessage(w)
    invokeRestart("muffleWarning")
  }
)
stopifnot(
  grepl("Install the missing package before using this file type", missing_file_package_error),
  grepl("gendercoderDefinitelyMissingPackage", missing_file_package_warning)
)

if (requireNamespace("shiny", quietly = TRUE)) {
  shiny_namespace <- asNamespace("shiny")
  original_run_app <- get("runApp", envir = shiny_namespace)
  unlockBinding("runApp", shiny_namespace)
  assign(
    "runApp",
    function(appDir, ...) list(appDir = appDir, args = list(...)),
    envir = shiny_namespace
  )
  lockBinding("runApp", shiny_namespace)

  app_launch <- gendercoder_app(launch.browser = FALSE)

  unlockBinding("runApp", shiny_namespace)
  assign("runApp", original_run_app, envir = shiny_namespace)
  lockBinding("runApp", shiny_namespace)

  stopifnot(
    identical(app_launch$args$launch.browser, FALSE),
    grepl("app$", app_launch$appDir)
  )
}

suggested_dictionary <- gender_create_dictionary(
  c("maile", "I am male", "apache"),
  dictionary = manylevels_en,
  max_distance = 1
)
stopifnot(
  identical(suggested_dictionary[["maile"]], "man"),
  !("I am male" %in% names(suggested_dictionary)),
  !("apache" %in% names(suggested_dictionary))
)

combined_dictionary <- c(suggested_dictionary, manylevels_en)
stopifnot(identical(
  recode_gender("maile", dictionary = combined_dictionary),
  "man"
))

#' Create a custom dictionary from fuzzy matches
#'
#' \code{gender_create_dictionary} suggests dictionary entries for gender
#' responses that are not already matched exactly. The returned named character
#' vector is intended to be reviewed before it is combined with a built-in
#' dictionary and passed to \code{recode_gender()}.
#'
#' @param gender a character vector of gender responses for recoding
#' @param dictionary a character vector whose names are known gender responses
#'   and whose values are replacement values
#' @param max_distance maximum edit distance allowed for a suggested match
#'
#' @return a named character vector of suggested replacement values
#'
#' @examples
#' suggested <- gender_create_dictionary(
#'   c("maile", "unknown"),
#'   dictionary = manylevels_en,
#'   max_distance = 1
#' )
#' suggested
#'
#' @export
gender_create_dictionary <- function(gender,
                                     dictionary = gendercoder::manylevels_en,
                                     max_distance = 1) {
  gender <- as.character(gender)

  if (!is.character(dictionary)) {
    stop("The supplied dictionary is not a character vector")
  }

  if (!is.numeric(max_distance) || length(max_distance) != 1 || max_distance < 0) {
    stop("max_distance must be a single non-negative number")
  }

  dictionary <- tolower(dictionary)
  names(dictionary) <- tolower(names(dictionary))
  dictionary <- dictionary[!duplicated(names(dictionary))]

  gender_clean <- tolower(trimws(gender))
  unmatched <- unique(gender_clean[is.na(dictionary[gender_clean])])
  unmatched <- unmatched[!is.na(unmatched) & nzchar(unmatched)]

  suggestions <- character()
  dictionary_names <- names(dictionary)

  for (response in unmatched) {
    distances <- utils::adist(response, dictionary_names)
    closest <- which.min(distances)

    if (length(closest) == 1 && distances[[closest]] <= max_distance) {
      suggestions[response] <- dictionary[[closest]]
    }
  }

  suggestions
}

#' recode_gender
#'
#' \code{recode_gender} matches uncleaned gender responses to cleaned list using
#' an built-in or custom dictionary.
#'
#' @param gender a character vector of gender responses for recoding
#' @param dictionary a list that the contains gender responses and their
#'   replacement values. A built-in dictionary \code{manylevels_en} is used by
#'   default if an alternative dictionary is not supplied.
#' @param retain_unmatched logical indicating if gender responses that are not found in
#'   dictionary should be filled with the uncleaned values during recoding
#'
#' @return a character vector of recoded genders
#'
#' @examples
#'
#'
#' df <- data.frame(
#'   stringsAsFactors = FALSE,
#'   gender = c("male", "MALE", "mle", "I am male", "femail", "female", "enby"),
#'   age = c(34L, 37L, 77L, 52L, 68L, 67L, 83L)
#' )
#'
#' df$recoded_gender <- recode_gender(df$gender,
#'   dictionary = manylevels_en,
#'   retain_unmatched = TRUE
#' )
#' df
#'
#' @export recode_gender
recode_gender <- function(gender,
                          dictionary = gendercoder::manylevels_en,
                          retain_unmatched = FALSE) {
  # Ensure that gender is treated as character so that non-character input
  # still produces an output of the same length.
  gender <- as.character(gender)

  if (!is.character(dictionary)) {
    stop("The supplied dictionary is not a character vector")
  }

  # Normalize the dictionary
  dictionary <- tolower(dictionary)
  names(dictionary) <- tolower(names(dictionary))
  dictionary <- dictionary[!duplicated(names(dictionary))]

  # Clean the gender input
  gender_lower <- tolower(trimws(gender))
  recoded <- dictionary[gender_lower]

  if (retain_unmatched) {
    unmatched_indices <- which(is.na(recoded))
    if (length(unmatched_indices) > 0) {
      message("Results not matched from the dictionary have been filled with the user inputted values")
      recoded[unmatched_indices] <- gender[unmatched_indices]
    }
  }

  unname(recoded)
}

#' gendercoder: A Package for Recoding Freetext Gender Data
#'
#' Provides dictionaries and \code{recode_gender()} to allow for easy automatic coding of common variations in free-text responses to the question \strong{"What is your gender?"}
#'
#' @docType package
#' @name gendercoder
NULL

#' sample
#'
#' A sample data.frame of free-text gender in English for testing and demonstration
#'
#' @name sample
#' @docType data
NULL

#' manylevels_en
#'
#' An English dictionary for the recode_gender function that has many levels
#'
#' @name manylevels_en
#' @docType data
NULL

#' fewlevels_en
#'
#' An English dictionary for the recode_gender function that has fewer levels
#'
#' @name fewlevels_en
#' @docType data
NULL

---
title: "Introduction to gendercoder"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Introduction to gendercoder}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

The goal of gendercoder is to allow simple recoding of free-text gender responses.

## Installation

You can install the development version from GitHub with:

``` r
devtools::install_github("ropensci/gendercoder")
library(gendercoder)
```

## Why would we do this?

Researchers who collect self-reported demographic data from respondents 
occasionally collect gender using a free-text response option. This has the 
advantage of respecting the gender diversity of respondents without prompting 
users and potentially including misleading responses. However, this presents a 
challenge to researchers in that some inconsistencies in typography and spelling 
create a larger set of responses than would be required to fully capture the 
demographic characteristics of the sample. 

For example, male participants may provide free-text responses as "male", "man", 
"mail", "mael". Non-binary participants may provide responses as "nonbinary", 
"enby", "non-binary", "non binary"

Manually coding of such free-text responses this is often not feasible with 
larger datasets. `recode_gender()` uses dictionaries of common
misspellings to re-code free-text responses into a consistent set of 
responses. The small number of responses not automatically re-coded by 
recode_gender() can then be feasibly manually recoded.

## Motivating example

`gendercoder` includes a sample dataset with actual free-text
responses to the question "What is your gender?" from a number of studies of 
English-speaking participants. The sample dataset includes responses from 7756
participants. Naive coding identifies 103 unique responses to this item. 


```{r message = FALSE, warning= FALSE}
library(gendercoder)

count_values <- function(x, name = "value") {
  counts <- sort(table(x, useNA = "ifany"), decreasing = TRUE)
  out <- data.frame(value = names(counts), count = as.integer(counts))
  names(out)[1] <- name
  out
}

knitr::kable(
  count_values(sample$Gender, "Gender"),
  caption = "Summary of gender categories before coding"
)
```

Recoding using the `gender_coder()` function classifies all but 28 responses 
into pre-defined response categories. 

```{r}
manylevels_sample <- sample
manylevels_sample$recoded_gender <- recode_gender(
  gender = manylevels_sample$Gender,
  dictionary = manylevels_en
)

knitr::kable(
  head(manylevels_sample, 10),
  caption = "The manylevels_en dictionary applied to `head(sample)`"
)

knitr::kable(
  count_values(na.omit(manylevels_sample$recoded_gender), "recoded_gender"),
  caption = "Summary of gender categories after use of the *manylevels_en* dictionary"
)

```

In this dataset unclassified responses are a mix of unusual responses and 
apparent response errors (e.g. numbers and symbols). While some of these are
genuinely missing (i.e. Gender = 40), other could be manually recoded, or added
to a custom dictionary. 

```{r}

knitr::kable(
  manylevels_sample[is.na(manylevels_sample$recoded_gender), ],
  caption = "All responses not classified by the built-in dictionary"
)

```

## Options within the function

### dictionary

The package provides two built-in dictionaries. The use of these is controlled 
using the `dictionary` argument. The first `dictionary = manylevels_en` provides 
corrects spelling and standardises terms while maintaining the diversity of responses. 
This is the default dictionary for `recode_gender()` as it preserves as much gender
diversity as possible. 

However in some cases you may wish to collapse gender into a smaller set of 
categories by using the `fewlevels_en` dictionary (`dictionary = fewlevels_en`). This 
dictionary contains fewer gender categories, "man", "woman", 
"boy", "girl", and "sex and gender diverse". 

The "man" category includes all participants who indicate that they are

- male
- trans male  (including female to male transgender respondents)
- cis male

The "woman" category includes all participants who indicate that they are

- female
- trans female (including male to female transgender respondents)
- cis female

The "sex and gender diverse" category includes all participants who indicate 
that they are

- agender
- androgynous
- intersex
- non-binary
- gender-queer

```{r} 
fewlevels_sample <- sample
fewlevels_sample$recoded_gender <- recode_gender(
  gender = fewlevels_sample$Gender,
  dictionary = fewlevels_en
)

knitr::kable(
  head(fewlevels_sample, 10),
  caption = "The fewlevels_en dictionary applied to `head(sample)`"
)

knitr::kable(
  count_values(fewlevels_sample$recoded_gender, "recoded_gender"),
  caption = "Summary of gender categories after use of the *fewlevels_en* dictionary"
)
```

You can also specify a custom dictionary to replace or supplement the built-in 
dictionary. The custom dictionary should be a list in the following 
format. 

```{r}
# name of the vector element is the user input value and the vector element is the 
# replacement value corresponding to that name as a lower case string.
custom_dictionary <- c(
  masculino = "man",
  hombre = "man",
  mujer = "woman",
  femenina = "woman"
)

str(custom_dictionary)
```

Custom dictionaries can be used in place of a built-in dictionary or can 
supplement the built-in dictionary by providing a vector of vectors to the 
dictionary argument. Where the lists contain duplicated elements, the last 
version of the duplicated value will be used for recoding. This allows you to 
use the built-in dictionary but change the coding of one or more responses from 
that dictionary. Here the addition of Spanish terms allows for recoding of 11 
previously uncoded responses.

```{r}

combined_sample <- sample
combined_sample$recoded_gender <- recode_gender(
  gender = combined_sample$Gender,
  dictionary = c(fewlevels_en, custom_dictionary)
)

knitr::kable(
  count_values(combined_sample$recoded_gender, "recoded_gender"),
  caption = "Summary of gender categories after use of the combined dictionaries"
)

knitr::kable(
  combined_sample[is.na(combined_sample$recoded_gender), ],
  caption = "All responses not classified by the combined dictionaries"
)
```

### retain_unmatched

The `retain_unmatched` argument is used to determine the handling for recoding of values
not contained in the dictionary. By default, unmatched values are coded as NA. 
`retain_unmatched = TRUE` will fill unmatched responses with the participant provided 
response. 

```{r}
retained_sample <- sample
retained_sample$recoded_gender <- recode_gender(
  gender = retained_sample$Gender,
  dictionary = c(fewlevels_en, custom_dictionary),
  retain_unmatched = TRUE
)

knitr::kable(
  count_values(retained_sample$recoded_gender, "recoded_gender"),
  caption = "Summary of gender categories after use of the combined dictionary and `retain_unmatched = TRUE`"
)
```

# A disclaimer on handling gender responses

This package attempts to remove typographical errors from free text gender data.
The defaults that we used are specific to our context and the time at which the 
package was developed and your data or context may be different. 

We offer two built-in dictionaries, manylevels_en and fewlevels_en. Both are necessarily 
opinionated about how gender descriptors collapse into categories. 

However, as these are culturally specific, they may not be suitable for your data. 
In particular the fewlevels_en option makes opinionated choices about some responses that we want to acknowledge are potentially problematic. Specifically,

- In 'fewlevels_en' coding intersex responses are recoded as 'sex and gender
diverse'
- In 'fewlevels_en' responses where people indicate they are trans and
indicate their identified gender are recoded as the identified gender
(e.g. 'Male to Female' is recoded as 'woman'). We wish to acknowledge
that this may not reflect how some individuals would classify
themselves when given these categories and in some contexts may make
systematic errors. The manylevels_en coding dictionary attempts to avoid these
issues as much as possible - however users can provide a custom
dictionary to add to or overwrite our coding decisions if they feel
this is more appropriate. We welcome people to update the built-in dictionary 
where desired responses are missing.
- In both dictionaries, we assume that typographical features such as spacing
are not relevant to recoding the gender response (e.g. we assume that
"genderqueer" and "gender queer" are equivalent). This is unlikely to be 
true for all contexts. 


The 'manylevels_en' coding separates out those who identify as trans
female/male or cis female/male into separate categories it should not
be assumed that all people who describe as male/female are cis, if you
are assessing trans status we recommend a two part question see:

Bauer, Greta & Braimoh, Jessica & Scheim, Ayden & Dharma, Christoffer.
(2017). Transgender-inclusive measures of sex/gender for population surveys:
Mixed-methods evaluation and recommendations. PLoS ONE. 12.

# Contributing to this package

This package is a reflection of cultural context of the package contributors. 
We acknowledge that understandings of gender are bound by both culture and time 
and are continually changing. As such, we welcome issues and pull requests to 
make the package more inclusive, more reflective of current understandings of 
gender inclusive languages and/or suitable for a broader range of cultural 
contexts. We particularly welcome addition of non-English dictionaries or of 
other gender-diverse responses to the manylevels_en and fewlevels_en dictionaries.

The "Adding to the dictionary" vignette includes information about how to make changes to the dictionary either for your own use or when contributing to the gendercoder package.

# Acknowledgement of Country

We acknowledge the Wurundjeri people of the Kulin Nation as the custodians of 
the land on which this package was developed and pay respects to elders past, 
present and future.

---
title: "Adding to the dictionary"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Adding to the dictionary}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup, echo = FALSE, message=FALSE}
df <- data.frame(
  gender = c("male", "enby", "womn", "mlae", "mann", "frau", "femme", "homme", "nin"),
  stringsAsFactors = FALSE
)
```
## Outline

While the `gendercoder` dictionaries aim to be as comprehensive as possible, it
is inevitable that new typos and variations will occur in wild data. Moreover, 
at present, the dictionaries are limited to data the authors have had access to 
which has been collected in English. As such, if you are collecting data, you 
will at some point want to add to or create your own dictionaries (and if so, 
we strongly encourage contributions either as [a pull request via GitHub](https://github.com/ropensci/gendercoder), or by [raising an issue](https://github.com/ropensci/gendercoder/issues/new) so the team can
help).

## Adding to the dictionary

Let's say I have free-text gender data, but some of it is not in English.

```{r example-data, message=FALSE}
library(gendercoder)
df
```

I can create a new dictionary by creating a named vector, where the names are 
the raw, uncoded values, and the values are the desired outputs. This can then 
be used as the dictionary in the `recode_gender()` function.

```{r new-dictionary}
new_dictionary <- c(
  mann = "man", 
  frau = "woman", 
  femme = "woman", 
  homme = "man", 
  nin = "man")

new_dictionary_df <- df
new_dictionary_df$recoded_gender <- recode_gender(
  df$gender,
  dictionary = new_dictionary,
  retain_unmatched = TRUE
)
new_dictionary_df

```
However, as you can see using just this new dictionary leaves a number of 
responses uncoded that the built-in dictionaries could handle. As the 
dictionaries are just vectors, we can simply concatenate these to use both at 
the same time. 

We can do this in-line...

```{r inline-augmentation}
inline_df <- df
inline_df$recoded_gender <- recode_gender(
  df$gender,
  dictionary = c(manylevels_en, new_dictionary),
  retain_unmatched = TRUE
)
inline_df
```
Or otherwise we can create a new dictionary and call that later, useful if you 
might want to save an augmented dictionary for later use or for contributing to 
the package.
```{r stepped-augmentation}
manylevels_plus <-  c(manylevels_en, new_dictionary)

stepped_df <- df
stepped_df$recoded_gender <- recode_gender(
  df$gender,
  dictionary = manylevels_plus,
  retain_unmatched = TRUE
)
stepped_df
```

## Making it official

Let's say you are happy with your `manylevels_plus` dictionary and think it should be 
part of the `manylevels_en` dictionary in the package. All you need to do is [fork the 
gendercoder repo](https://docs.github.com/en/get-started/quickstart/fork-a-repo), 
[clone it to your local device](https://docs.github.com/en/repositories/creating-and-managing-repositories/cloning-a-repository), and then rename 
your vector and use the `usethis::use_data()` function to overwrite the `manylevels_en` 
dictionary as shown below. 

```{r replacing-dictionaries, eval=FALSE}
manylevels_en <-  manylevels_plus
usethis::use_data(manylevels_en, overwrite = TRUE)
```

Once you've pushed the changes to your fork, you can [make a pull request](https://docs.github.com/en/pull-requests/collaborating-with-pull-requests/proposing-changes-to-your-work-with-pull-requests/creating-a-pull-request-from-a-fork). Please tell us 
what you're adding so we know what to look out for and how to test it.  

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gendercodeR.R
\docType{package}
\name{gendercoder}
\alias{gendercoder-package}
\alias{gendercoder}
\title{gendercoder: A Package for Recoding Freetext Gender Data}
\description{
Provides dictionaries and \code{recode_gender()} to allow for easy automatic coding of common variations in free-text responses to the question \strong{"What is your gender?"}
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/ropensci/gendercoder}
  \item Report bugs at \url{https://github.com/ropensci/gendercoder/issues}
}

}
\author{
\strong{Maintainer}: Yaoxiang Li \email{liyaoxiang@outlook.com} (\href{https://orcid.org/0000-0001-9200-1016}{ORCID})

Authors:
\itemize{
  \item Jennifer Beaudry \email{jbeaudry@swin.edu.au} (\href{https://orcid.org/0000-0003-1596-6708}{ORCID})
  \item Emily Kothe \email{emily.kothe@deakin.edu.au} (\href{https://orcid.org/0000-0003-1210-0554}{ORCID})
  \item Felix Singleton Thorn \email{fsingletonthorn@gmail.com} (\href{https://orcid.org/0000-0002-0237-6146}{ORCID})
  \item Rhydwyn McGuire \email{rhydwyn@rhydwyn.net}
  \item Nicholas Tierney \email{nicholas.tierney@gmail.com} (\href{https://orcid.org/0000-0003-1460-8722}{ORCID})
  \item Mathew Ling \email{mathewtyling@gmail.com} (\href{https://orcid.org/0000-0002-0940-2538}{ORCID})
}

Other contributors:
\itemize{
  \item Julia Silge (Julia reviewed the package (v. 0.0.0.9000) for rOpenSci, see <https://github.com/ropensci/software-review/issues/435>) [reviewer]
  \item Elin Waring (Elin reviewed the package (v. 0.0.0.9000) for rOpenSci, see <https://github.com/ropensci/software-review/issues/435>) [reviewer]
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gendercodeR.R
\docType{data}
\name{fewlevels_en}
\alias{fewlevels_en}
\title{fewlevels_en}
\description{
An English dictionary for the recode_gender function that has fewer levels
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/recode_gender.R
\name{recode_gender}
\alias{recode_gender}
\title{recode_gender}
\usage{
recode_gender(
  gender,
  dictionary = gendercoder::manylevels_en,
  retain_unmatched = FALSE
)
}
\arguments{
\item{gender}{a character vector of gender responses for recoding}

\item{dictionary}{a list that the contains gender responses and their
replacement values. A built-in dictionary \code{manylevels_en} is used by
default if an alternative dictionary is not supplied.}

\item{retain_unmatched}{logical indicating if gender responses that are not found in
dictionary should be filled with the uncleaned values during recoding}
}
\value{
a character vector of recoded genders
}
\description{
\code{recode_gender} matches uncleaned gender responses to cleaned list using
an built-in or custom dictionary.
}
\examples{


df <- data.frame(
  stringsAsFactors = FALSE,
  gender = c("male", "MALE", "mle", "I am male", "femail", "female", "enby"),
  age = c(34L, 37L, 77L, 52L, 68L, 67L, 83L)
)

df$recoded_gender <- recode_gender(df$gender,
  dictionary = manylevels_en,
  retain_unmatched = TRUE
)
df

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gendercoder_app.R
\name{gendercoder_app}
\alias{gendercoder_app}
\title{Launch the gendercoder Shiny app}
\usage{
gendercoder_app(...)
}
\arguments{
\item{...}{arguments to pass to \code{shiny::runApp()}}
}
\value{
Called for its side effect of launching a Shiny app.
}
\description{
Code data interactively in a Shiny app that runs locally in RStudio or a web
browser using a \pkg{bs4Dash} interface. The app supports CSV, Stata, SPSS,
RDS, and R data files. Stata and SPSS files require the optional
\pkg{haven} package.
}
\examples{
if (interactive()) {
gendercoder_app()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gendercodeR.R
\docType{data}
\name{manylevels_en}
\alias{manylevels_en}
\title{manylevels_en}
\description{
An English dictionary for the recode_gender function that has many levels
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gender_create_dictionary.R
\name{gender_create_dictionary}
\alias{gender_create_dictionary}
\title{Create a custom dictionary from fuzzy matches}
\usage{
gender_create_dictionary(
  gender,
  dictionary = gendercoder::manylevels_en,
  max_distance = 1
)
}
\arguments{
\item{gender}{a character vector of gender responses for recoding}

\item{dictionary}{a character vector whose names are known gender responses
and whose values are replacement values}

\item{max_distance}{maximum edit distance allowed for a suggested match}
}
\value{
a named character vector of suggested replacement values
}
\description{
\code{gender_create_dictionary} suggests dictionary entries for gender
responses that are not already matched exactly. The returned named character
vector is intended to be reviewed before it is combined with a built-in
dictionary and passed to \code{recode_gender()}.
}
\examples{
suggested <- gender_create_dictionary(
  c("maile", "unknown"),
  dictionary = manylevels_en,
  max_distance = 1
)
suggested

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gendercodeR.R
\docType{data}
\name{sample}
\alias{sample}
\title{sample}
\description{
A sample data.frame of free-text gender in English for testing and demonstration
}
